<template>
    <div>
        <canvas id="wall" width="800" height="400" tabindex="0"/>
    </div>
</template>

<script lang="ts">
import { SGraphScene, SGraphView } from "@persagy-web/graph/";
import { SWallItem } from "@persagy-web/big/lib/items/floor/SWallItem";
import { Component, Vue } from "vue-property-decorator";

/**
 * 墙对象示例
 *
 * @author 郝洁 <haojie@persagy.com>
 */
@Component
export default class WallCanvas extends Vue {
    /** 实例化 view */
    view: SGraphView | undefined;
    /** 图中靠上位置的黑色矩形轮廓 */
    outline1 = [[{X: 120, Y: 10}, {X: 120, Y: 30}, {X: 10, Y: 30}, {X: 10, Y: 10}]];
    /** 图中靠下位置的,中间掏洞 */
    outline2 = [
        [{X: 120, Y: -30}, {X: 120, Y: -50}, {X: 10, Y: -50}, {X: 10, Y: -30}],
        [{X: 20, Y: -40}, {X: 20, Y: -45}, {X: 100, Y: -45}, {X: 100, Y: -40}]
    ];

    /**
     * 页面挂载
     */
    mounted() {
        this.init();
    };

    /**
     * 初始化加载
     */
    init() {
        this.view = new SGraphView('wall');
        const scene = new SGraphScene();
        this.view.scene = scene;
        // 只模拟了轮廓数据
        const item = new SWallItem(null, {OutLine: this.outline1});
        scene.addItem(item);
        // 只模拟了轮廓数据
        const item2 = new SWallItem(null, {OutLine: this.outline2});
        scene.addItem(item2);
        this.view.fitSceneToView();
        this.view.scalable = false;
    }
}
</script>

<style scoped>

</style>
